#include "stdafx.h"
#include "NeMessenger.h"
#include "InfoOutlinkWnd.h"
#include "XHyperLink.h"
#include "httpclient.h"

IMPLEMENT_DYNAMIC(CInfoOutlinkWnd, CWnd)

CInfoOutlinkWnd::CInfoOutlinkWnd()
{
	// BG
	m_pImgBG = NULL;
	m_pImgItem = NULL;
	m_pImgItemOver = NULL;
	m_pImgItemDown = NULL;
	m_pImgItemBorder = NULL;

	// dimension
	m_rtWnd.SetRectEmpty();
	m_rtLeftArrow.SetRectEmpty();
	m_rtRightArrow.SetRectEmpty();
	m_rtItem.SetRectEmpty();

	// font
	_tcscpy_s(m_wszFontName, g_defaultFontFaceName);
	m_nFontHeight = DEF_ITEM_FONT_HEIGHT;
	m_fontStyle = DEF_ITEM_FONT_STYLE;
	m_crText = DEF_ITEM_FONT_COLOR;

	// tracking
	m_bTracking = FALSE;
}

CInfoOutlinkWnd::~CInfoOutlinkWnd()
{
}

BEGIN_MESSAGE_MAP(CInfoOutlinkWnd, CWnd)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_BN_CLICKED(ID_BTN_LEFT_ARROW,		OnBtnClickedLeftArrow)
	ON_BN_CLICKED(ID_BTN_RIGHT_ARROW,		OnBtnClickedRightArrow)
	ON_WM_MOUSEMOVE()
	ON_WM_MOUSEHOVER()
	ON_WM_MOUSELEAVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
END_MESSAGE_MAP()

void CInfoOutlinkWnd::ClearOutlinkItemAll()
{
	_outlink_item_info* pOIInfo = NULL;

	int nCntItem = m_ptrArItem.GetCount();
	for (int i = 0; i < nCntItem; i++)
	{
		pOIInfo = (_outlink_item_info*)m_ptrArItem.GetAt(i);
		if (!pOIInfo)
			continue;

		SAFE_DELETE(pOIInfo->pIconImage);
		delete pOIInfo;
	}
	m_ptrArItem.RemoveAll();
}

void CInfoOutlinkWnd::SetImgBGPath(CString strFileName)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	m_pImgBG = new Image(strImgPath);
}

void CInfoOutlinkWnd::SetImgItemPath(CString strFileName, CString strFileNameOver, CString strFileNameClick)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	m_pImgItem = new Image(strImgPath);

	if (strFileNameOver.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileNameOver);

	m_pImgItemOver = new Image(strImgPath);

	if (strFileNameClick.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileNameClick);

	m_pImgItemDown = new Image(strImgPath);
}

void CInfoOutlinkWnd::SetImgItemBorderPath(CString strFileName)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	m_pImgItemBorder = new Image(strImgPath);
}

void CInfoOutlinkWnd::SetFontConfig(WCHAR* wszFontName, REAL nFontHeight, FontStyle style, Color crText)
{
	_tcscpy_s(m_wszFontName, wszFontName);
	m_nFontHeight = nFontHeight;
	m_fontStyle = style;

	m_crText = crText;
}

CInfoOutlinkWnd::_outlink_item_info* CInfoOutlinkWnd::AllocOutlinkItem(CString strText, CString strURL, CString strIconURL)
{
	_outlink_item_info* pOIInfo = new _outlink_item_info;

	if (!pOIInfo)
		return NULL;

	pOIInfo->nType = OL_TYPE_TEXT;
	pOIInfo->strText = strText;
	pOIInfo->strURL = strURL;

	if (!strIconURL.IsEmpty())
	{
		pOIInfo->nType = OL_TYPE_ICON;
		pOIInfo->strIconFilePath = GetIconFilePathFromURL(strIconURL);

		if (PathFileExists(pOIInfo->strIconFilePath))
		{
			pOIInfo->pIconImage = new Image(pOIInfo->strIconFilePath);
		}
		else
		{
			OLThreadParam* pParam = new OLThreadParam;

			if (!pParam)
			{
				delete pOIInfo;
				return NULL;
			}

			pParam->pMainWnd = this;
			pParam->strIconURL = strIconURL;

			CWinThread *pThread = AfxBeginThread(ThreadDownloadIcon, pParam, THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED);
			if (pThread == NULL)
			{
				delete pParam;
				TRACE(_T("Failed to create outlink image download thread.\n"));
			}
			else
			{
				pThread->ResumeThread();
			}
		}
	}

	return pOIInfo;
}

CString CInfoOutlinkWnd::GetIconFilePathFromURL(CString strURL)
{
	CString strOutlinkDirPath = _T("");
	strOutlinkDirPath.Format(_T("%s\\Outlink\\"), GET_APP()->GetAppDataDir());

	if (_waccess(strOutlinkDirPath, 0) == -1)
		_wmkdir(strOutlinkDirPath);

	CString strFileName = _T("");

	int nFirst = strURL.ReverseFind(_T('/')) + 1;
	int nLast = strURL.ReverseFind(_T('?'));
	
	if (nLast > nFirst)
	{
		strFileName = strURL.Mid(nFirst, nLast - nFirst);
	}
	else
	{
		strFileName = strURL.Mid(nFirst);
	}

	strOutlinkDirPath.Append(strFileName);
	return strOutlinkDirPath;
}

UINT CInfoOutlinkWnd::ThreadDownloadIcon(LPVOID pParam)
{
	if( pParam == NULL )
		return 0;

	OLThreadParam* pThreadParam = (OLThreadParam*)pParam;
	CInfoOutlinkWnd* pMainWnd = (CInfoOutlinkWnd*)pThreadParam->pMainWnd;

	CString strIconFilePath = GetIconFilePathFromURL(pThreadParam->strIconURL);

	if (PathFileExists(strIconFilePath))
	{
		pMainWnd->LoadIconImage(strIconFilePath);
		delete pThreadParam;
		return 0;
	}

	httpbase::GenericHTTPClient httpClient;

	httpClient.Request(NULL, pThreadParam->strIconURL, httpbase::GenericHTTPClient::RequestGetMethod, strIconFilePath);

	pMainWnd->LoadIconImage(strIconFilePath);
	delete pThreadParam;

	return 0;
}

void CInfoOutlinkWnd::AddOutlinkItem(NE_OUTLINK_DATA &outlink)
{
	_outlink_item_info* pOIInfo = NULL;
	pOIInfo = AllocOutlinkItem(outlink.strTitle.c_str(), outlink.strLinkURL.c_str(), outlink.strIconURL.c_str());
	if (!pOIInfo)
		return;

	_outlink_item_info* pOIInfoLast = NULL;

	int nCntItem = m_ptrArItem.GetSize();
	if (nCntItem > 0)
		pOIInfoLast = (_outlink_item_info*)m_ptrArItem.GetAt(nCntItem - 1);

	int nSXItem = m_rtItem.left;
	int nSYItem = m_rtItem.top + 1;
	if (pOIInfoLast)
		nSXItem = pOIInfoLast->rtItem.right + DEF_ITEM_BORDER_WIDTH + 1;

	CSize szItem(0, 0);

	if (pOIInfo->nType == OL_TYPE_TEXT)
	{
		REAL nFontHeight = m_nFontHeight;
		CRect rtItem(0, 0, 500, 500);
		RecalcTextRect(this, pOIInfo->strText, m_wszFontName, nFontHeight, m_fontStyle, rtItem, szItem);
	}
	else
	{
		szItem.cx = DEF_ITEM_ICON_WIDTH;
		szItem.cy = DEF_ITEM_ICON_HEIGHT;
	}

	int nCXItem = szItem.cx + (2 * DEF_ITEM_TEXT_MARGIN);
	int nCYItem = m_rtItem.Height() - 2;
	pOIInfo->rtItem.SetRect(nSXItem, nSYItem, nSXItem + nCXItem, nSYItem + nCYItem);

	pOIInfo->szText = szItem;
	pOIInfo->rtText = pOIInfo->rtItem;
	pOIInfo->rtText.top = (m_rtItem.Height() - szItem.cy) / 2;
	pOIInfo->rtText.bottom = pOIInfo->rtText.top + szItem.cy;

	if (pOIInfo->nType == OL_TYPE_ICON)
	{
		pOIInfo->rtText.left = pOIInfo->rtText.left + (pOIInfo->rtItem.Width() / 2 - (DEF_ITEM_ICON_WIDTH / 2));
		pOIInfo->rtText.right = pOIInfo->rtText.left + DEF_ITEM_ICON_WIDTH;
	}

	m_ptrArItem.Add(pOIInfo);
}

int CInfoOutlinkWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	m_btnLeftArrow.Create(_T(""), WS_CHILD | WS_VISIBLE | BS_OWNERDRAW, CRect(0, 0, 0, 0), this, ID_BTN_LEFT_ARROW);
	m_btnLeftArrow.SetBtnBitmapFile(GetAppImgFile(_T("New_Info_Outlink_Left_Arrow.bmp")), RGB(255, 0, 255));

	m_btnRightArrow.Create(_T(""), WS_CHILD | WS_VISIBLE | BS_OWNERDRAW, CRect(0, 0, 0, 0), this, ID_BTN_RIGHT_ARROW);
	m_btnRightArrow.SetBtnBitmapFile(GetAppImgFile(_T("New_Info_Outlink_Right_Arrow.bmp")), RGB(255, 0, 255));

	return 0;
}

void CInfoOutlinkWnd::OnDestroy()
{
	if (m_pImgBG)
	{
		delete m_pImgBG;
		m_pImgBG = NULL;
	}
	if (m_pImgItem)
	{
		delete m_pImgItem;
		m_pImgItem = NULL;
	}
	if (m_pImgItemOver)
	{
		delete m_pImgItemOver;
		m_pImgItemOver = NULL;
	}
	if (m_pImgItemDown)
	{
		delete m_pImgItemDown;
		m_pImgItemDown = NULL;
	}
	if (m_pImgItemBorder)
	{
		delete m_pImgItemBorder;
		m_pImgItemBorder = NULL;
	}

	if (m_btnLeftArrow.GetSafeHwnd())
		m_btnLeftArrow.DestroyWindow();
	if (m_btnRightArrow.GetSafeHwnd())
		m_btnRightArrow.DestroyWindow();

	ClearOutlinkItemAll();

	CWnd::OnDestroy();
}

BOOL CInfoOutlinkWnd::OnEraseBkgnd(CDC* pDC)
{
	return TRUE;
}

void CInfoOutlinkWnd::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	
	PAINTSTRUCT ps = dc.m_ps;
	int psWidth = ps.rcPaint.right - ps.rcPaint.left;
	int psHeight = ps.rcPaint.bottom - ps.rcPaint.top;

	int nPX = ps.rcPaint.left;
	int nPY = ps.rcPaint.top;

	CRect rtPS(nPX, nPY, nPX + psWidth, nPY + psHeight);

	CRect rt(0, 0, 0, 0);
	GetClientRect(&rt);
	//int nWndWidth = rt.Width();
	//int nWndHeight = rt.Height();

	HDC hdc = dc.GetSafeHdc();

	HDC	hdcMemory = CreateCompatibleDC(hdc);

	if (hdcMemory == NULL)
		return;

	HBITMAP hbmpMem = CreateCompatibleBitmap(hdc, psWidth, psHeight);

	HGDIOBJ hbmpOld = ::SelectObject(hdcMemory,  hbmpMem);

	Graphics graph(hdcMemory);

	if (hbmpMem)
	{
		graph.SetSmoothingMode(SmoothingModeAntiAlias);
		graph.SetInterpolationMode(InterpolationModeHighQualityBicubic);
		graph.SetPageUnit(UnitPixel);

		ImageAttributes ImgAttr;

		if (m_pImgBG)
			DrawImageToStretchHorz(&graph, m_pImgBG, &rtPS, &m_rtWnd, Color(255, 200, 200, 200), &ImgAttr);

		int nCntItem = m_ptrArItem.GetCount();
		_outlink_item_info* pOIInfo = NULL;
		for (int i = 0; i < nCntItem; i++)
		{
			pOIInfo = (_outlink_item_info*)m_ptrArItem.GetAt(i);
			if (!pOIInfo)
				continue;

			if (pOIInfo->rtItem.right < m_rtItem.left)
				continue;

			Image* pImgItem = m_pImgItem;
			if (pOIInfo->bHover)
				pImgItem = m_pImgItemOver;
			if (pOIInfo->bDown)
				pImgItem = m_pImgItemDown;
			if (pImgItem)
				DrawImageToStretchHorzExceptL(&graph, pImgItem, &rtPS, &(pOIInfo->rtItem), 1, &ImgAttr);

			if (m_pImgItemBorder)
			{
				CRect rtBorder = pOIInfo->rtItem;
				rtBorder.left = rtBorder.right + 1;
				rtBorder.right = rtBorder.left + DEF_ITEM_BORDER_WIDTH;
				DrawImageToDest(&graph, m_pImgItemBorder, &rtPS, &rtBorder, &ImgAttr);
			}

			if (pOIInfo->nType == OL_TYPE_TEXT && !(pOIInfo->strText.IsEmpty()))
			{
				CRect rtText = pOIInfo->rtText;
				DrawTextToDest2(&graph, pOIInfo->strText, &rtPS, &rtText, m_wszFontName, m_nFontHeight, StringAlignmentCenter, m_fontStyle, m_crText);

				Pen pen(Color(255, 255, 0, 0), 1);
				int nSX = pOIInfo->rtItem.left - rtPS.left;
				int nSY = pOIInfo->rtItem.top - rtPS.top;
			}
			else	// OL_TYPE_ICON
			{
				if (pOIInfo->pIconImage)
				{
					CRect rtText = pOIInfo->rtText;
					DrawImageToDest(&graph, pOIInfo->pIconImage, &rtPS, &rtText, &ImgAttr);
				}
			}
		}

		BitBlt(dc.GetSafeHdc(), nPX, nPY, psWidth, psHeight, hdcMemory, 0, 0, SRCCOPY);

		::SelectObject(hdcMemory, hbmpOld);
		::DeleteObject(hbmpMem);
	}

	::DeleteDC(hdcMemory);
}

CInfoOutlinkWnd::_outlink_item_info* CInfoOutlinkWnd::GetFirstVisibleItem(CInfoOutlinkWnd::_outlink_item_info*& pOIPrior)
{
	int nCntItem = m_ptrArItem.GetCount();
	if (nCntItem <= 0)
		return NULL;

	_outlink_item_info* pOIInfo = NULL, *pOIInfoRet = NULL;
	for (int i = 0; i < nCntItem; i++)
	{
		pOIInfo = (_outlink_item_info*)m_ptrArItem.GetAt(i);
		if (!pOIInfo)
			continue;

		if (pOIInfo->rtItem.right > m_rtLeftArrow.right)
		{
			pOIInfoRet = pOIInfo;
			break;
		}
		pOIPrior = pOIInfo;
	}

	return pOIInfoRet;
}

CInfoOutlinkWnd::_outlink_item_info* CInfoOutlinkWnd::GetLastVisibleItem(CInfoOutlinkWnd::_outlink_item_info*& pOINext)
{
	int nCntItem = m_ptrArItem.GetCount();
	if (nCntItem <= 0)
		return NULL;

	_outlink_item_info* pOIInfo = NULL, *pOIInfoRet = NULL;
	for (int i = nCntItem - 1; i >= 0; i--)
	{
		pOIInfo = (_outlink_item_info*)m_ptrArItem.GetAt(i);
		if (!pOIInfo)
			continue;

		if (pOIInfo->rtItem.left < m_rtRightArrow.left)
		{
			pOIInfoRet = pOIInfo;
			break;
		}
		pOINext = pOIInfo;
	}

	return pOIInfoRet;
}

void CInfoOutlinkWnd::OnBtnClickedLeftArrow()
{
	_outlink_item_info* pOIInfoFirstVisible = NULL, *pOIInfoPrior = NULL;
	pOIInfoFirstVisible = GetFirstVisibleItem(pOIInfoPrior);
	if (!pOIInfoFirstVisible)
		return;

	int nDiff = 0;
	if (pOIInfoFirstVisible->rtItem.left < m_rtLeftArrow.right)
		nDiff = m_rtLeftArrow.right - pOIInfoFirstVisible->rtItem.left;
	else
	{
		if (pOIInfoPrior)
			nDiff = pOIInfoPrior->rtItem.Width() + DEF_ITEM_BORDER_WIDTH + 1;
	}

	ScrollItemInc(nDiff, FALSE);

	UpdateBtnInfo();
}

void CInfoOutlinkWnd::OnBtnClickedRightArrow()
{
	_outlink_item_info* pOIInfoLastVisible = NULL, *pOIInfoNext = NULL;
	pOIInfoLastVisible = GetLastVisibleItem(pOIInfoNext);
	if (!pOIInfoLastVisible)
		return;

	int nDiff = 0;
	if (pOIInfoLastVisible->rtItem.right > m_rtRightArrow.left)
		nDiff = pOIInfoLastVisible->rtItem.right - m_rtRightArrow.left + 1;
	else
	{
		if (pOIInfoNext)
			nDiff = pOIInfoNext->rtItem.Width() + DEF_ITEM_BORDER_WIDTH + 1;
	}

	ScrollItemInc(nDiff, TRUE);

	UpdateBtnInfo();
}

void CInfoOutlinkWnd::ScrollItemInc(int nDiff, BOOL bLeft)
{
	int nScroll = 1;
	if (bLeft)
		nScroll *= (-1);
	while (nDiff > 0)
	{
		ScrollItem(nScroll);
		
		RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);

		nDiff--;
	}
}

void CInfoOutlinkWnd::ScrollItem(int nScroll)
{
	int nCntItem = m_ptrArItem.GetCount();
	if (nCntItem <= 0)
		return;

	_outlink_item_info* pOIInfo = NULL;
	for (int i = 0; i < nCntItem; i++)
	{
		pOIInfo = (_outlink_item_info*)m_ptrArItem.GetAt(i);
		if (!pOIInfo)
			continue;

		pOIInfo->rtItem.OffsetRect(nScroll, 0);
		pOIInfo->rtText.OffsetRect(nScroll, 0);
	}
}

void CInfoOutlinkWnd::RecalcItemInfo()
{
	UpdateBtnInfo();

	int nCntItem = m_ptrArItem.GetCount();
	if (nCntItem <= 0)
		return;

	_outlink_item_info* pOIInfo = NULL;
	for (int i = 0; i < nCntItem; i++)
	{
		pOIInfo = (_outlink_item_info*)m_ptrArItem.GetAt(i);
		if (!pOIInfo)
			continue;

		pOIInfo->rtItem.top = m_rtItem.top + 1;
		pOIInfo->rtItem.bottom = m_rtItem.Height() - 1;

		pOIInfo->rtText = pOIInfo->rtItem;
		pOIInfo->rtText.top = (m_rtItem.Height() - pOIInfo->szText.cy) / 2;
		pOIInfo->rtText.bottom = pOIInfo->rtText.top + pOIInfo->szText.cy;

		if (pOIInfo->nType == OL_TYPE_ICON)
		{
			pOIInfo->rtText.left = pOIInfo->rtText.left + (pOIInfo->rtItem.Width() / 2 - (DEF_ITEM_ICON_WIDTH / 2));
			pOIInfo->rtText.right = pOIInfo->rtText.left + DEF_ITEM_ICON_WIDTH;
		}
	}

	_outlink_item_info* pOIInfoFirst = NULL, *pOIInfoLast = NULL;
	pOIInfoFirst = (_outlink_item_info*)m_ptrArItem.GetAt(0);
	pOIInfoLast = (_outlink_item_info*)m_ptrArItem.GetAt(nCntItem - 1);

	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

void CInfoOutlinkWnd::UpdateBtnInfo()
{
	int nCntItem = m_ptrArItem.GetCount();
	if (nCntItem <= 0)
	{
		m_btnLeftArrow.SetButtonDisable();
		m_btnRightArrow.SetButtonDisable();
		return;
	}

	_outlink_item_info* pOIInfo = NULL, *pOIInfoFirst = NULL, *pOIInfoLast = NULL;
	_outlink_item_info* pOIInfoFirstVisible = NULL, *pOIInfoLastVisible = NULL;
	_outlink_item_info* pOIInfoNext = NULL, *pOIInfoPrior = NULL;

	pOIInfoFirst = (_outlink_item_info*)m_ptrArItem.GetAt(0);
	pOIInfoLast = (_outlink_item_info*)m_ptrArItem.GetAt(nCntItem - 1);
	pOIInfoFirstVisible = GetFirstVisibleItem(pOIInfoPrior);
	pOIInfoLastVisible = GetLastVisibleItem(pOIInfoNext);

	if (pOIInfoFirstVisible == NULL || pOIInfoLastVisible == NULL)
		return;

	if ((pOIInfoLast != pOIInfoLastVisible) || (pOIInfoLastVisible->rtItem.right > m_rtRightArrow.left))
	{
		m_btnRightArrow.SetButtonEnable();
	}
	else
	{
		m_btnRightArrow.SetButtonDisable();
	}

	if ((pOIInfoFirst != pOIInfoFirstVisible) || (pOIInfoFirstVisible->rtItem.left < m_rtLeftArrow.right))
	{
		m_btnLeftArrow.SetButtonEnable();
	}
	else
	{
		m_btnLeftArrow.SetButtonDisable();
	}
}

void CInfoOutlinkWnd::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	m_rtWnd.SetRect(0, 0, cx, cy);

	int nSX = 0, nSY = 0, nCX = 0, nCY = 0;
	if (m_btnLeftArrow.GetSafeHwnd())
	{
		nSX = 0;
		nSY = 0;
		nCX = m_btnLeftArrow.GetImgWidth();
		nCY = m_btnLeftArrow.GetImgHeight();
		m_rtLeftArrow.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

		m_btnLeftArrow.MoveWindow(&m_rtLeftArrow);
	}
	if (m_btnRightArrow.GetSafeHwnd())
	{
		nCX = m_btnRightArrow.GetImgWidth();
		nCY = m_btnRightArrow.GetImgHeight();
		nSX = m_rtWnd.right - nCX;
		nSY = 0;		
		m_rtRightArrow.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

		m_btnRightArrow.MoveWindow(&m_rtRightArrow);
	}

	nSX = m_rtLeftArrow.right;
	nSY = 0;
	nCX = m_rtWnd.Width() - m_rtLeftArrow.Width() - m_rtRightArrow.Width();
	nCY = m_rtWnd.Height();
	m_rtItem.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

	RecalcItemInfo();
}

void CInfoOutlinkWnd::OnMouseMove(UINT nFlags, CPoint point)
{
	int nCntItem = m_ptrArItem.GetCount();
	if (nCntItem <= 0)
		return;

	BOOL bUpdate = FALSE;
	CRect rtUpdate(0, 0, 0, 0);

	_outlink_item_info* pOIInfo = NULL;
	for (int i = 0; i < nCntItem; i++)
	{
		pOIInfo = (_outlink_item_info*)m_ptrArItem.GetAt(i);
		if (!pOIInfo)
			continue;

		BOOL bHover = FALSE;
		if (pOIInfo->rtItem.PtInRect(point))
		{
			bHover = TRUE;
		}

		if (pOIInfo->bHover != bHover)
		{
			pOIInfo->bHover = bHover;
			rtUpdate.UnionRect(&rtUpdate, &(pOIInfo->rtItem));
			bUpdate = TRUE;
		}
	}
	if (bUpdate)
		RedrawWindow(&rtUpdate, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);

	if (!m_bTracking)
	{
		m_bTracking = TRUE;

		TRACKMOUSEEVENT tme;
		tme.cbSize = sizeof(TRACKMOUSEEVENT);
		tme.dwFlags = TME_HOVER | TME_LEAVE;
		tme.dwHoverTime = 1;
		tme.hwndTrack = GetSafeHwnd();
		TrackMouseEvent(&tme);
	}

	CWnd::OnMouseMove(nFlags, point);
}

void CInfoOutlinkWnd::OnMouseHover(UINT nFlags, CPoint point)
{
	
}

void CInfoOutlinkWnd::OnMouseLeave()
{
	m_bTracking = FALSE;

	BOOL bUpdate = FALSE;
	CRect rtUpdate(0, 0, 0, 0);

	int nCntItem = m_ptrArItem.GetCount();
	_outlink_item_info* pOIInfo = NULL;
	for (int i = 0; i < nCntItem; i++)
	{
		pOIInfo = (_outlink_item_info*)m_ptrArItem.GetAt(i);
		if (!pOIInfo)
			continue;

		BOOL bHover = FALSE;
		if (pOIInfo->bHover != bHover)
		{
			pOIInfo->bHover = bHover;
			rtUpdate.UnionRect(&rtUpdate, &(pOIInfo->rtItem));
			bUpdate = TRUE;
		}
	}
	if (bUpdate)
		RedrawWindow(&rtUpdate, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

void CInfoOutlinkWnd::OnLButtonDown(UINT nFlags, CPoint point)
{
	int nCntItem = m_ptrArItem.GetCount();
	if (nCntItem <= 0)
		return;

	BOOL bUpdate = FALSE;
	CRect rtUpdate(0, 0, 0, 0);

	_outlink_item_info* pOIInfo = NULL;
	for (int i = 0; i < nCntItem; i++)
	{
		pOIInfo = (_outlink_item_info*)m_ptrArItem.GetAt(i);
		if (!pOIInfo)
			continue;

		BOOL bDown = FALSE;
		if (pOIInfo->rtItem.PtInRect(point))
		{
			bDown = TRUE;
		}

		if (pOIInfo->bDown != bDown)
		{
			pOIInfo->bDown = bDown;
			rtUpdate.UnionRect(&rtUpdate, &(pOIInfo->rtItem));
			if (!bUpdate)
				SetCapture();

			bUpdate = TRUE;
		}
	}
	if (bUpdate)
		RedrawWindow(&rtUpdate, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);

	CWnd::OnLButtonDown(nFlags, point);
}

void CInfoOutlinkWnd::OnLButtonUp(UINT nFlags, CPoint point)
{
	ReleaseCapture();

	int nCntItem = m_ptrArItem.GetCount();
	if (nCntItem <= 0)
		return;

	BOOL bUpdate = FALSE;
	CRect rtUpdate(0, 0, 0, 0);

	_outlink_item_info* pOIInfo = NULL;
	for (int i = 0; i < nCntItem; i++)
	{
		pOIInfo = (_outlink_item_info*)m_ptrArItem.GetAt(i);
		if (!pOIInfo)
			continue;

		if (pOIInfo->bDown && pOIInfo->rtItem.PtInRect(point))
		{
			if (FALSE == CXHyperLink::UseAlreadyOpenedIE(pOIInfo->strURL))
			{
				CXHyperLink::GotoURL(pOIInfo->strURL, SW_SHOWNORMAL);
			}
		}

		if (pOIInfo->bDown != FALSE)
		{
			pOIInfo->bDown = FALSE;
			rtUpdate.UnionRect(&rtUpdate, &(pOIInfo->rtItem));
			bUpdate = TRUE;
		}
	}
	if (bUpdate)
		RedrawWindow(&rtUpdate, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);

	CWnd::OnLButtonUp(nFlags, point);
}

void CInfoOutlinkWnd::LoadIconImage(CString strIconPath)
{
	if (strIconPath.IsEmpty() || !PathFileExists(strIconPath))
		return;

	int nCntItem = m_ptrArItem.GetCount();
	if (nCntItem <= 0)
		return;

	BOOL bUpdate = FALSE;

	_outlink_item_info* pOIInfo = NULL;
	for (int i = 0; i < nCntItem; i++)
	{
		pOIInfo = (_outlink_item_info*)m_ptrArItem.GetAt(i);
		if (!pOIInfo)
			continue;

		if (pOIInfo->strIconFilePath.CompareNoCase(strIconPath) == 0)
		{
			SAFE_DELETE(pOIInfo->pIconImage);
			pOIInfo->pIconImage = new Image(strIconPath);
			bUpdate = TRUE;

			break;
		}
	}

	if (bUpdate)
		RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}
